;
;
;   SHOWTOPOSHOTINFO.LSP 
;
;         
;       .
;
;   ---------------------------------------------------------------------
;
;       ShowToposhotInfo, 
;        AutoCAD,   
;      .
;
;          
;    SHOWTOPOSHOTINFO.DCL,     
;    . 
;
;         
;        
;     .
;
;   ---------------------------------------------------------------------
;
;   Copyright (C) 2005, 2014 CSoft Development
;   All rights reserved.
;
;

;
;   show-toposhot-info-dialog (
;       attr-list            ;--     "=".
;   )
;
;          
;       .
;
;       
;      
;       .
;

(defun show-toposhot-info-dialog (attr-list / dlg-name dlg-id attr param-to-list)

    (setq dlg-name "toposhot_info_dialog")

    ;
    ;    param-to-list (
    ;        param-string    ;--     "=".
    ;    )
    ;
    ;      "="   ("" "").
    ;

    (defun param-to-list (param-string / i result)

        (setq i 1)
       
        (while (<= i (strlen param-string))
            (if (= (substr param-string i 1) "=")
                (progn
                    (setq result (list (substr param-string 1 (- i 1)) 
                                       (substr param-string (+ i 1)) 
                                 )
                    )
                    (setq i (strlen param-string))
                )
            )
            (setq i (1+ i))
        )

        (progn result)
    )    

    ;      
    ;     .

    (if (setq dlg-id (load_dialog "showtoposhotinfo.dcl"))
        (if (new_dialog dlg-name dlg-id)
            (progn
                (foreach attr (mapcar 'param-to-list attr-list)
                    (set_tile (car attr) (cadr attr))
                ) 
                (start_dialog)
                (unload_dialog dlg-id)
            )
            (alert "   .")
        )
        (alert "     .")
    )
)

;
;   ShowToposhotInfo (
;   )
;
;        
;    ,     
;     AutoCAD.
;
;       ,  
;           .
;
;          
;         .
;

(defun C:ShowToposhotInfo ( / select-by-type show-info)

    ;
    ;   select-by-type (
    ;       pair-list        ;--    .
    ;       type             ;--    .
    ;   )
    ;
    ;        ( ) 
    ;       ,   
    ;     .
    ; 

    (defun select-by-type (pair-list type / head tail resultant-list)

        (setq tail pair-list)

        (while tail
            (setq head (car tail))

            (if (= (car head) type)
                (setq resultant-list (cons (cdr head) resultant-list))
            )

            (setq tail (cdr tail))
        )

        (progn resultant-list)
    )     

    ;
    ;   show-info (
    ;   )
    ;  
    ;       ,  
    ;          .
    ;
    ;         
    ;       .
    ;

    (defun show-info ( / ade-attr-list string-attr-list APPLICATION ATTR_SECTION ATTR_TYPE)

        ;      ,
        ;       DXF.

        (setq APPLICATION "ADE")
        (setq ATTR_SECTION -3)
        (setq ATTR_TYPE 1000)  ;--  .
    
        ;         
        ;    .

        (if (setq ade-attr-list 
                (cdadr (assoc ATTR_SECTION (entget (car (entsel)) (list APPLICATION))))
            )

            ;       
            ;        .

            (if (setq string-attr-list (select-by-type ade-attr-list ATTR_TYPE))
                (show-toposhot-info-dialog string-attr-list)
                (alert "     .")
            )
            (alert "     .")
        )
    )

    ;        
    ;    .

    (show-info)
    (princ)
)